local SmokeEnabled, SmokeR, SmokeG, SmokeB, SmokeSize = false, 0.0, 0.0, 0.0, 1.0

local PlayerSmokeSettings = {}

local offsets = {
	[GetHashKey("f4")] = {0.0, -8.0, 0.0},
	[GetHashKey("f4blu")] = {0.0, -8.0, 0.0},
	[GetHashKey("f22a")] = {0.0, -6.0, 0.0},
	[GetHashKey("a10")] = {0.0, -7.2, 0.5},
	[GetHashKey("b52n")] = {0.0, -7.2, 0.5},
	[GetHashKey("nasax15")] = {0.0, -7.2, 0.5},
	[GetHashKey("un26")] = {0.0, -7.2, 0.5},
	[GetHashKey("whitehawk")] = {0.0, -7.2, 0.5},
	[GetHashKey("sh3")] = {0.0, -7.2, 0.5},
	[GetHashKey("tonado")] = {0.0, -7.2, 0.5},
	[GetHashKey("ef9")] = {0.0, -7.2, 0.5},
	[GetHashKey("typhoon")] = {0.0, -7.2, 0.5},
	[GetHashKey("snowbird")] = {0.0, -7.2, 0.5},
	[GetHashKey("hawker")] = {0.0, -7.2, 0.5},
	[GetHashKey("fa18fm")] = {0.0, -7.2, 0.5},
	[GetHashKey("fa18f")] = {0.0, -7.2, 0.5},
	[GetHashKey("an225")] = {0.0, -7.2, 0.5},
	[GetHashKey("thunderb")] = {0.0, -7.2, 0.5},
	[GetHashKey("seahawk")] = {0.0, -7.2, 0.5},
	[GetHashKey("sh60b")] = {0.0, -7.2, 0.5},
	[GetHashKey("seaknight")] = {0.0, -7.2, 0.5},
	[GetHashKey("stallion")] = {0.0, -7.2, 0.5},
	[GetHashKey("rah66")] = {0.0, -7.2, 0.5},
	[GetHashKey("osprey")] = {0.0, -7.2, 0.5},
	[GetHashKey("globe")] = {0.0, -7.2, 0.5},
	[GetHashKey("oh58")] = {0.0, -7.2, 0.5},
	[GetHashKey("uh1raaf2")] = {0.0, -7.2, 0.5},
	[GetHashKey("uh1raaf")] = {0.0, -7.2, 0.5},
	[GetHashKey("pavelow")] = {0.0, -7.2, 0.5},
	[GetHashKey("pavehawk")] = {0.0, -7.2, 0.5},
	[GetHashKey("p3")] = {0.0, -7.2, 0.5},
	[GetHashKey("e4b")] = {0.0, -7.2, 0.5},
	[GetHashKey("nh90")] = {0.0, -7.2, 0.5},
	[GetHashKey("kc390")] = {0.0, -7.2, 0.5},
	[GetHashKey("lcac")] = {0.0, -7.2, 0.5},
	[GetHashKey("foxch47")] = {0.0, -7.2, 0.5},
	[GetHashKey("foxch47b")] = {0.0, -7.2, 0.5},
	[GetHashKey("kc130j")] = {0.0, -7.2, 0.5},
	[GetHashKey("f4blue")] = {0.0, -7.2, 0.5},
	[GetHashKey("f5adv")] = {0.0, -7.2, 0.5},
	[GetHashKey("f4uc")] = {0.0, -7.2, 0.5},
	[GetHashKey("c17raaf")] = {0.0, -7.2, 0.5},
	[GetHashKey("hornet")] = {0.0, -7.2, 0.5},
	[GetHashKey("kc135r")] = {0.0, -7.2, 0.5},
	[GetHashKey("f16demo")] = {0.0, -7.2, 0.5},
	[GetHashKey("f16tb")] = {0.0, -7.2, 0.5},
	[GetHashKey("eagle")] = {0.0, -7.2, 0.5},
	[GetHashKey("galaxy")] = {0.0, -7.2, 0.5},
	[GetHashKey("besra")] = {0.0, -7.2, 0.5},
	[GetHashKey("f18blue")] = {0.0, -7.2, 0.5},
	[GetHashKey("as350")] = {0.0, -7.2, 0.5},
	[GetHashKey("mc27us")] = {0.0, -7.2, 0.5},
	[GetHashKey("mc27uk")] = {0.0, -7.2, 0.5},
	[GetHashKey("mc27au")] = {0.0, -7.2, 0.5},
	[GetHashKey("b52")] = {0.0, -7.2, 0.5},
	[GetHashKey("ah64d")] = {0.0, -7.2, 0.5},
	[GetHashKey("atr")] = {0.0, -7.2, 0.5},
	[GetHashKey("ac130u")] = {0.0, -7.2, 0.5},
	[GetHashKey("cessna")] = {0.0, -7.2, 0.5},
	[GetHashKey("f15c")] = {0.0, -6.0, 0.0}
}
RegisterNetEvent('JM36-FSRP:PlaneSmokeSettingsUpdate')
AddEventHandler('JM36-FSRP:PlaneSmokeSettingsUpdate', function(Data)
	PlayerSmokeSettings = Data
end)

local function UpdatePlaneSmokeSettings(sEnabled, sR, sG, sB, sSize)
	SmokeEnabled, SmokeR, SmokeG, SmokeB, SmokeSize = sEnabled, sR, sG, sB, sSize
	TriggerServerEvent("JM36-FSRP:PlaneSmokeSettingsUpdate", {SmokeEnabled, SmokeR, SmokeG, SmokeB, SmokeSize})
end

Citizen.CreateThread(function()
	while true do
		Citizen.Wait(0)
		if IsControlJustPressed(0, 20) and IsPedInAnyPlane(PlayerPedId()) then
			UpdatePlaneSmokeSettings(not SmokeEnabled, SmokeR, SmokeG, SmokeB, SmokeSize)
		end
	end
end)
local ActiveFx = {}
Citizen.CreateThread(function()
	local particleDictionary = "scr_ar_planes"
	local particleName = "scr_ar_trail_smoke"
	RequestNamedPtfxAsset(particleDictionary)
	while not HasNamedPtfxAssetLoaded(particleDictionary) do
		Citizen.Wait(0)
	end
	while true do
		Citizen.Wait(0)
		for _, player in ipairs(GetActivePlayers()) do
			local ped = GetPlayerPed(player)
			local veh = GetVehiclePedIsUsing(ped)
			local Data = PlayerSmokeSettings[GetPlayerServerId(player)]
			if Data ~= nil then
				local SmokeEnabled, SmokeR, SmokeG, SmokeB, SmokeSize = table.unpack(Data)
				if (IsPedInAnyPlane(ped) and not IsEntityDead(veh)) and SmokeEnabled then
					if not ActiveFx[veh] then
						UseParticleFxAssetNextCall(particleDictionary)
						local ox, oy, oz = 0.0, 0.0, 0.0
						ActiveFx[veh] = StartNetworkedParticleFxLoopedOnEntityBone(particleName, veh, ox, oy, oz, 0.0, 0.0, 0.0, -1, SmokeSize + 0.0, ox, oy, oz)
					elseif ActiveFx[veh] and not IsEntityDead(veh) then
						SetParticleFxLoopedScale(ActiveFx[veh], SmokeSize+0.0)
						SetParticleFxLoopedRange(ActiveFx[veh], 10000.0)
						SetParticleFxLoopedColour(ActiveFx[veh], SmokeR + 0.0, SmokeG + 0.0, SmokeB + 0.0)
					end
				else
					if ActiveFx[veh] or IsEntityDead(veh) or not veh then
						StopParticleFxLooped(ActiveFx[veh], 0)
						ActiveFx[veh] = nil
					end
				end
			end
		end
	end
end)

Citizen.CreateThread(function()
	TriggerEvent('chat:addSuggestion', '/smokecolor', 'Changes the color of your plane smoke!', {
	{ name="color", help="Sets a specific color. Supported: red, blue, yellow, purple, cyan, green, pink, black, white." }
})
end)
Citizen.CreateThread(function()
	TriggerEvent('chat:addSuggestion', '/smokesize', 'Changes the size of your plane smoke!', {
	{ name="size", help="Sets a specific size. Example: 5.0 (Values must have have .0)" }
})
end)

function msg(text)
	TriggerEvent("chatMessage", "[INFS]", { 158, 123, 202}, text)
end
RegisterCommand("smokecolor", function(source, args, raw)
	local ped = PlayerPedId()
	local veh = GetVehiclePedIsUsing(ped)
	if offsets[GetEntityModel(veh)] then
		if string.lower(args[1]) == "red" then
			msg("^1Smoke color set to red!")
			UpdatePlaneSmokeSettings(SmokeEnabled, 255.0, 0.0, 0.0, SmokeSize)
		elseif string.lower(args[1]) == "blue" then
			msg("^4Smoke color set to blue!")
			UpdatePlaneSmokeSettings(SmokeEnabled, 0.0, 0.0, 255.0, SmokeSize)
		elseif string.lower(args[1]) == "green" then
			msg("^2Smoke color set to green!")
			UpdatePlaneSmokeSettings(SmokeEnabled, 0.0, 255.0, 0.0, SmokeSize)
		elseif string.lower(args[1]) == "purple" then
			msg("Smoke color set to purple!")
			UpdatePlaneSmokeSettings(SmokeEnabled, 128.0, 0.0, 128.0, SmokeSize)
		elseif string.lower(args[1]) == "cyan" then
			msg("^5Smoke color set to cyan!")
			UpdatePlaneSmokeSettings(SmokeEnabled, 0.0, 100.0, 255.0, SmokeSize)
		elseif string.lower(args[1]) == "black" then
			msg("^0Smoke color set to black!")
			UpdatePlaneSmokeSettings(SmokeEnabled, 0.0, 0.0, 0.0, SmokeSize)
		elseif string.lower(args[1]) == "pink" then
			msg("^6Smoke color set to pink!")
			UpdatePlaneSmokeSettings(SmokeEnabled, 68.0, 0.0, 255.0, SmokeSize)
		elseif string.lower(args[1]) == "yellow" then
			msg("^3Smoke color set to yellow!")
			UpdatePlaneSmokeSettings(SmokeEnabled, 102.0, 255.0, 0.0, SmokeSize)
		elseif string.lower(args[1]) == "orange" then
			msg("Smoke color set to orange!")
			UpdatePlaneSmokeSettings(SmokeEnabled, 255.0, 165.0, 0.0, SmokeSize)
		elseif string.lower(args[1]) == "white" then
			msg("^7Smoke color set to white!")
			UpdatePlaneSmokeSettings(SmokeEnabled, 255.0, 255.0, 255.0, SmokeSize)
		else
			msg("Smoke color set to custom rgb code!")
			UpdatePlaneSmokeSettings(SmokeEnabled, tonumber(args[1]) + 0.0, tonumber(args[2]) + 0.0, tonumber(args[3]) + 0.0, SmokeSize)
		end
	end
end)
RegisterCommand("smokesize", function(source, args, raw)
	local SmokeSize = tonumber(args[1]) + 0.0
	if SmokeSize > 5.0 then SmokeSize = 5.0 elseif SmokeSize <= 0.0 then SmokeSize = 0.1 end
	UpdatePlaneSmokeSettings(SmokeEnabled, SmokeR, SmokeG, SmokeB, SmokeSize)
end)
UpdatePlaneSmokeSettings(SmokeEnabled, SmokeR, SmokeG, SmokeB, SmokeSize)